from lib.SyncerTypes import *
import glob
import fnmatch
import os
import re
import shutil
from shutil import copyfile

class handler_plank(IPlugin):

    def init_plugin(self):
        self.typeplug = 'plank'
        self.params = ['action','option']

    def search_item(self,location,name):
        if location == 'applications':
            loc='/usr/share/applications/'
            ext='[.]desktop'
            file_re = re.compile(name + ext + '$', re.IGNORECASE)
        elif location == 'plank':
            loc=os.path.expanduser('~')+'/.config/plank/dock1/launchers/'
            ext='[.]dockitem'
            if name == 'all':
                reg='\S+' +ext + '$'
                file_re = re.compile(reg, re.IGNORECASE)
            else:
                file_re = re.compile(name + ext + '$', re.IGNORECASE)
        elif location == 'skel':
            loc='/etc/skel/.config/plank/dock1/launchers/'
            ext='[.]dockitem'
            file_re = re.compile(name + ext + '$', re.IGNORECASE)
        else:
            return None

        try:
            filelist=[]
            for root,dirnames,filenames in os.walk(loc):
                for file in filenames:
                    if file_re.match(file):
                        if name != 'all':
                            return os.path.join(root,file)
                        else:
                            filelist.append(os.path.join(root,file))
                return filelist

        except:
            return None

    def get_skel(self):
        try:
            file_names = [filename for filename in glob.iglob('/etc/skel/.config/plank/dock1/launchers/*.dockitem', recursive=True)]
        except:
            return None
        return file_names
    def get_locals(self):
        try:
            file_names = [filename for filename in glob.iglob(os.path.expanduser('~')+'/.config/plank/dock1/launchers/*.dockitem', recursive=True)]
        except:
            return None
        return file_names

    def process(self,*args,**kwargs):
        params = kwargs['params']
        if params['action'] == 'addcontent':
            item = params['option']
            basename_item = os.path.basename(item)
            if not os.path.exists(item):
                return False,str(item)
            folder = os.path.expanduser('~')+'/.config/syncer-plank'
            if not os.path.exists(folder):
                os.mkdir(folder)
            newitem = folder+'/'+basename_item+'.desktop'
            shutil.move(item,newitem)
            os.chmod(newitem,0o0755)
            # maybe it's a dockitem
            content = None
            with open(newitem,'r') as fp:
                content = fp.read()
            if 'PlankDockItemPreferences' in content:
                with open(os.path.expanduser('~')+'/.config/plank/dock1/launchers/'+basename_item+'.dockitem','w') as f:
                    f.write(content)
            else:
                # create element
                entry=['[PlankDockItemPreferences]','Launcher=file://'+newitem]
                entry=map(lambda x: x+'\n',entry)
                with open(os.path.expanduser('~')+'/.config/plank/dock1/launchers/'+basename_item+'.dockitem','w') as f:
                    f.writelines(entry)
            return True,'Added {}'.format(item)

        elif params['action']== 'add':
            try:
                where='applications'
                #search into applications
                file_name=self.search_item(where,params['option'])
                if file_name == None or file_name == []:
                    #if not found search into skel
                    where='skel'
                    file_name = self.search_item(where, params['option'])
                    if not file_name:
                        return True,'Not found '+params['option']

                # check if already added
                if self.search_item('plank',params['option']):
                    return True,'Already added'

                # create element
                if where == 'applications':
                    entry=['[PlankDockItemPreferences]','Launcher=file://'+file_name]
                    entry=map(lambda x: x+'\n',entry)
                else:
                    with open(file_name,'r') as f:
                        entry=f.readlines()
                with open(os.path.expanduser('~')+'/.config/plank/dock1/launchers/'+params['option']+'.dockitem','w') as f:
                    f.writelines(entry)

                return True,'Added {}'.format(file_name)
            except Exception as e:
                return True,'Not added, error is: {}'.format(str(e))
        elif params['action'] == 'remove':
            try:
                if params['option'].lower() == 'all':
                    filenames=self.search_item('plank','all')
                    for x in filenames:
                        os.remove(x)
                    return True, "Removed {} elements".format(len(filenames))
                else:
                    file_name = self.search_item('plank',params['option'])
                    if file_name == None:
                        return False,'Not found '+os.path.expanduser('~')+'/.config/plank/dock1/launchers/'+params['option']+'.dockitem'
                    os.remove(file_name)

                    return True,"Removed {}".format(file_name)
            except Exception as e:
                return False,str(e)
        elif params['action'] == 'restore':
            try:
                i=0
                for x in self.get_skel():
                    i+=1
                    destname=x.split('/')
                    copyfile(x,os.path.expanduser('~')+'/.config/plank/dock1/launchers/'+destname[-1])
                return True,'{} elements copied'.format(i)
            except Exception as e:
                return False,str(e)
        elif params['action'] == 'reset':
            try:
                i=0
                for x in self.get_locals():
                    i+=1
                    os.remove(x)
                return True,'{} elements removed'.format(i)
            except Exception as e:
                return False,str(e)
        else:
            return False,'Invalid action'
